/**@file

// cpcSteppingMotorConfig.ctl
This library contains the import and export function of the CPC_SteppingMotor.

@par Creation Date
  dd/mm/yyyy

@par Modification History

@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author
  the author (DEP-GROUP)

@copyright
        &copy;Copyright CERN 2013 - all rights reserved
*/
//@{



// Constants
const string UN_CONFIG_CPC_STEPPINGMOTOR_DPT_NAME = "CPC_SteppingMotor";
//begin_TAG_SCRIPT_DEVICE_TYPE_constants
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_LENGTH = 26;

const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_UNIT = 1;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_FORMAT = 2;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_RANGEMAX = 3;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_RANGEMIN = 4;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_SPDST_RANGEMAX = 5;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_SPDST_RANGEMIN = 6;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_DEADBAND = 7;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_DEADBAND_TYPE = 8;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ARCHIVE_ACTIVE = 9;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ARCHIVE_TIME_FILTER = 10;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_NORMAL_POSITION = 11;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_STSREG01 = 12;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_STSREG02 = 13;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_EVSTSREG01 = 14;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_EVSTSREG02 = 15;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_POSST = 16;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_SPDST = 17;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_POSRST = 18;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_SPDRST = 19;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_AUPOSRST = 20;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_AUSPDRST = 21;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_MPOSRST = 22;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_MSPDRST = 23;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_MANREG01 = 24;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_MPOSR = 25;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDRESS_MSPDR = 26;

const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_LENGTH          = 7;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_MASKEVENT       = 1;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_PARAMETERS      = 2;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_MASTER_NAME     = 3;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_PARENTS         = 4;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_CHILDREN        = 5;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_TYPE            = 6;
const unsigned UN_CONFIG_CPC_STEPPINGMOTOR_ADDITIONAL_SECOND_ALIAS    = 7;
//end_TAG_SCRIPT_DEVICE_TYPE_constants


/**
DPE configuration
TODO: use fw info instead
*/
mapping CPC_SteppingMotorConfig_getConfig() {
    mapping config;
    mapping props;

//begin_TAG_SCRIPT_DEVICE_TYPE_deviceConfig
    mappingClear(props);
    props["address"]      = ".ProcessInput.StsReg01";
    props["dataType"]     = CPC_UINT16;
    config["StsReg01"]    = props;

    mappingClear(props);
    props["address"]      = ".ProcessInput.StsReg02";
    props["dataType"]     = CPC_UINT16;
    config["StsReg02"]    = props;

    mappingClear(props);
    props["hasArchive"] 	= true;
    props["address"] 		= ".ProcessInput.evStsReg01";
    props["dataType"] 		= CPC_INT32;
    config["evStsReg01"] 	= props;

    mappingClear(props);
    props["hasArchive"] 	= true;
    props["address"] 		= ".ProcessInput.evStsReg02";
    props["dataType"] 		= CPC_INT32;
    config["evStsReg02"] 	= props;

    mappingClear(props);
    props["hasUnit"] 		= true;
    props["hasFormat"]		= true;
    props["hasSmooth"] 		= true;
    props["hasArchive"] 	= true;
    props["hasPvRange"] 	= true;
    props["address"] 		= ".ProcessInput.PosSt";
    props["dataType"] 		= CPC_FLOAT;
    config["PosSt"] 		   = props;

    mappingClear(props);
    props["hasFormat"]		= false;
    props["hasSmooth"] 		= true;
    props["hasArchive"] 	= true;
    props["hasPvRange"] 	= true;
    props["address"] 		= ".ProcessInput.SpdSt";
    props["dataType"] 		= CPC_UINT16;
    config["SpdSt"] 		  = props;

    mappingClear(props);
    props["hasSmooth"] 		= true;
    props["hasArchive"] 	= true;
    props["hasUnit"] 		= true;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.PosRSt";
    props["dataType"] 		= CPC_FLOAT;
    config["PosRSt"] 		= props;

    mappingClear(props);
    props["hasSmooth"] 		= false;
    props["hasArchive"] 	= true;
    props["hasUnit"] 		= false;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.SpdRSt";
    props["dataType"] 		= CPC_UINT16;
    config["SpdRSt"]       = props;

    mappingClear(props);
    props["hasFormat"]		= true;
    props["hasSmooth"] 		= true;
    props["hasUnit"] 		= true;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.AuPosRSt";
    props["dataType"] 		= CPC_FLOAT;
    config["AuPosRSt"] 		= props;

    mappingClear(props);
    props["hasFormat"]		= true;
    props["hasSmooth"] 		= true;
    props["hasUnit"] 		= false;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.AuSpdRSt";
    props["dataType"] 		= CPC_UINT16;
    config["AuSpdRSt"] 		= props;

    mappingClear(props);
    props["hasFormat"]		= true;
    props["hasSmooth"] 		= true;
    props["hasUnit"] 		= true;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.MPosRSt";
    props["dataType"] 		= CPC_FLOAT;
    config["MPosRSt"] 		= props;

    mappingClear(props);
    props["hasSmooth"] 		= true;
    props["hasUnit"] 		= false;
    props["hasFormat"]		= true;
    props["address"] 		= ".ProcessInput.MSpdRSt";
    props["dataType"] 		= CPC_UINT16;
    config["MSpdRSt"] 		= props;

    mappingClear(props);
    props["address"] 		= ".ProcessInput.StartISt";
    props["dpe"]			   = "StsReg01";
    props["bitPosition"]	= CPC_StsReg01_STARTIST;
    props["isAlarm"]		   = true;
    config["StartISt"] 		= props;

    mappingClear(props);
    props["address"] 		= ".ProcessInput.TStopISt";
    props["dpe"]			   = "StsReg01";
    props["bitPosition"]	= CPC_StsReg01_TSTOPIST;
    props["isAlarm"]		   = true;
    config["TStopISt"] 		= props;

    mappingClear(props);
    props["address"] 		= ".ProcessInput.FuStopISt";
    props["dpe"]		    	= "StsReg02";
    props["bitPosition"]	= CPC_StsReg02_FUSTOPIST;
    props["isAlarm"]		   = true;
    config["FuStopISt"] 	= props;

    mappingClear(props);
    props["address"]      = ".ProcessInput.AlSt";
    props["dpe"]          = "StsReg01";
    props["bitPosition"]  = CPC_StsReg01_ALST;
    props["isAlarm"]      = true;
    config["AlSt"]        = props;

    mappingClear(props);
    props["address"]      = ".ProcessInput.AlUnAck";
    props["dpe"]          = "StsReg01";
    props["bitPosition"]  = CPC_StsReg01_ALUNACK;
    config["AlUnAck"]     = props;

    mappingClear(props);
    props["address"] 		= ".ProcessOutput.ManReg01";
    props["dataType"] 		= CPC_UINT16;
    config["ManReg01"] 		= props;

    mappingClear(props);
    props["address"] 		= ".ProcessOutput.MPosR";
    props["dataType"] 		= CPC_FLOAT;
    config["MPosR"] 		= props;

    mappingClear(props);
    props["address"] 		= ".ProcessOutput.MSpdR";
    props["dataType"] 		= CPC_UINT16;
    config["MSpdR"] 		= props;

//end_TAG_SCRIPT_DEVICE_TYPE_deviceConfig

    return config;
}

/**
Returns the list of parameter names that passed via config line.
*/
dyn_string CPC_SteppingMotorConfig_getParamNames() {
//begin_TAG_SCRIPT_DEVICE_TYPE_getParamNames
    return makeDynString(CPC_PARAMS_MRESTART, CPC_PARAMS_RSTARTFS);
//end_TAG_SCRIPT_DEVICE_TYPE_getParamNames
}

/** Set custom configuration
*/
CPC_SteppingMotorConfig_setCustomConfig(dyn_string dsConfigs, bool hasArchive, dyn_string &exceptionInfo) {
//begin_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
    cpcDpFunc_fixAckPropogation(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], ".ProcessInput.TStopISt");
    cpcDpFunc_fixAckPropogation(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], ".ProcessInput.FuStopISt");
    cpcDpFunc_fixAckPropogation(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], ".ProcessInput.StartISt");
    cpcDpFunc_fixAckPropogation(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], ".ProcessInput.AlSt");
//end_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
}

/**
Purpose: Export CPC_SteppingMotor Devices

Usage: External function

PVSS manager usage: NG, NV
*/
CPC_SteppingMotorConfig_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    string sObject = UN_CONFIG_CPC_STEPPINGMOTOR_DPT_NAME;
    int amount = dynlen(dsDpList);
    for (int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if (!dpExists(currentDP)) { continue; }

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
//begin_TAG_SCRIPT_DEVICE_TYPE_export
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.SpdSt");
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getDigitalNormalPosition(currentDP, sObject, makeDynString(".ProcessInput.StartISt", ".ProcessInput.TStopISt", ".ProcessInput.FuStopISt"), dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg01", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg02", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg01", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg02", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "SpdSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosRSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "SpdRSt",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuPosRSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "AuSpdRSt",    true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MPosRSt",     true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MSpdRSt",     true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg01", 	false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MPosR", 		false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MSpdR", 		false, dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, cpcExportGenericFunctions_getArchivedDpes(sObject, UN_CONFIG_ADDITIONAL_ARCHIVE_BOOL), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, cpcExportGenericFunctions_getArchivedDpes(sObject, UN_CONFIG_ADDITIONAL_ARCHIVE_ANALOG), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, cpcExportGenericFunctions_getArchivedDpes(sObject, UN_CONFIG_ADDITIONAL_ARCHIVE_EVENT), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getParameters(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getMetainfo(currentDP, dsDpParameters, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_export

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}

/**
Purpose: Export CPC_SteppingMotor Devices for S7_PLC front-end

Usage: External function

PVSS manager usage: NG, NV
*/
S7_PLC_CPC_SteppingMotor_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_SteppingMotorConfig_ExportConfig(dsDpList, exceptionInfo);
}

/**
Purpose: Export CPC_SteppingMotor Devices for _UnPlc front-end

Usage: External function

PVSS manager usage: NG, NV
*/
_UnPlc_CPC_SteppingMotor_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_SteppingMotorConfig_ExportConfig(dsDpList, exceptionInfo);
}

OPCUA_CPC_SteppingMotor_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_SteppingMotorConfig_ExportConfig(dsDpList, exceptionInfo);
}

BACnet_CPC_SteppingMotor_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo) {
    CPC_SteppingMotorConfig_ExportConfig(dsDpList, exceptionInfo);
}

//@}
