/**
 * UNICOS
 * Copyright (C) CERN 2013 All rights reserved
 */
/**@file

// unRcpConstant_declarations.ctl
This file contains the constant definitions for the UNICOS Recipes.

@par Creation Date
  27/05/2011

@par Modification History
  
@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author 
  Ivan Prieto Barreiro (EN-ICE)
*/

//@{

// Recipe Constant Definitions
const string UN_CONFIG_UNRCPCLASS_DPT_NAME 			   = "UnRcpClass";
const string UN_CONFIG_UNRCPTYPE_DPT_NAME  			   = "UnRcpType";
const string UN_CONFIG_UNRCPINSTANCE_DPT_NAME 		   = "UnRcpInstance";
const string UN_CONFIG_INTERNAL_UNRCPCLASS_DPT_NAME    = "_UnRcpClass";
const string UN_CONFIG_INTERNAL_UNRCPINSTANCE_DPT_NAME = "_UnRcpInstance";
const string UN_RECIPE_FE_ALIAS                        = "RCP_FE";

const unsigned UN_CONFIG_UNRCPCLASS_MIN_LENGHT   = 2;  // Min length of the recipe class definition; before the device order was introduced 
const unsigned UN_CONFIG_UNRCPCLASS_MAX_LENGHT   = 3;  // Max length of the recipe class definition; after the device order was introduced
const unsigned UN_CONFIG_UNRCPCLASS_RECIPE_TYPE  = 1;  // Recipe class type
const unsigned UN_CONFIG_UNRCPCLASS_DEVICE_LIST  = 2;  // Recipe class device list
const unsigned UN_CONFIG_UNRCPCLASS_DEVICE_ORDER = 3;  // Device order

const unsigned UN_CONFIG_UNRCPINSTANCE_LENGHT = 3;
const unsigned UN_CONFIG_UNRCPINSTANCE_RECIPE_CLASS = 1;	// Recipe class of the recipe instance
const unsigned UN_CONFIG_UNRCPINSTANCE_INITIAL_RECIPE = 2;	// Is an initial recipe?
const unsigned UN_CONFIG_UNRCPINSTANCE_VALUES_LIST = 3;		// Values list

// constant for export

// constant for widget

// constant for faceplate

// constant for device action interface

// Recipe instance states
const string UN_RCP_INSTANCE_STATE_ACTIVATE  	  = "Activate";
const string UN_RCP_INSTANCE_STATE_EDIT		 	  = "Edit";
const string UN_RCP_INSTANCE_STATE_DELETE	 	  = "Delete";
const string UN_RCP_INSTANCE_STATE_INVALID	 	  = "Invalid";
const string UN_RCP_INSTANCE_STATE_DUPLICATE 	  = "Duplicate";
const string UN_RCP_INSTANCE_STATE_CANCELLED 	  = "Cancelled";
const string UN_RCP_INSTANCE_STATE_UNLOCK_BUFFERS = "Unlocking Buffers";
const string UN_RCP_INSTANCE_STATE_LOADING_VALUES = "Loading Values";
const string UN_RCP_INSTANCE_STATE_LOCKED = "Locked";

// Predefined recipe instance to store the configuration data (AC Domain and privileges)
const string UN_RCP_PREDEFINED_NAME 		  = "__Predefined__";
const string UN_RCP_PREDEFINED_RCPCLASS_ALIAS = "_UnRcpClass__Predefined__";
const string UN_RCP_PREDEFINED_RCPCLASS_DPE   = "un-/-/-_UnRcpClass-00000";


// Recipe class states
const string UN_RCP_CLASS_STATE_EDIT		                = "Edit";
const string UN_RCP_CLASS_STATE_INVALID	 	                = "Invalid";
const string UN_RCP_CLASS_STATE_INVALID_EDIT                = "Invalid Edit";
const string UN_RCP_CLASS_STATE_APPLY_CHANGES               = "Apply Changes";
const string UN_RCP_ACTION_ACTIVATE_INITIAL_RECIPES 		= "ActivateInitialRecipes";
const string UN_RCP_ACTION_ACTIVATE_LAST_ACTIVATED_RECIPES 	= "ActivateLastActivatedRecipes";

const string UN_RCP_SAVE_TO_DB_STATE                        = "Save to DB";

const string UN_RCP_WARNING_MESSAGE_CLASS_MODIFIED          = "Warning! The recipe class has been modified. Please reload the recipe to avoid inconsistencies.";
const string UN_RCP_WARNING_MESSAGE_VALUES_MODIFIED         = "Warning! The recipe values have been modified. Please reload the recipe to avoid inconsistencies.";

//@}

//@{

// put here the global variables

//@}

